
/***************************************************************************
                fm_conf.h  -  Handles configuration of SC
                             -------------------
    begin                : Mon Jan 3 2000
    copyright            : (C) 2000 by MoP
    email                : sc@poulsen.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef _FM_CONF
#define _FM_CONF

//#include "fm_defs.h"

#include "target.h"
#include <string>
#include "array.h"
#include "sc_usermenu.h"

#ifdef _FTP_POSSIBLE_
  #include "sc_ftp.h"
#endif

#define _NUMBEROFQUICKDIRS 10
//#define _MAXMENUOPTION 16


struct sExtCommand {
  string ext;
  string commandline;
  bool view;
};

enum tMenuActionType {maJustRun, maEdit, maView, maCapture, maMulti};

struct sMenuOption {   //A structure containing info about a menuoption
  string showline;     //what to show in menu
  string commandline;  //command to execute
  tMenuActionType type;
};

class cFmConfig {
  public:
    string GetConfigFilename();

    bool ReadConfigFile();
    bool WriteConfigFile();

    bool usesimplechars;

    //Linesetup
    bool showsize;
    bool showattr;
    bool showdate;
    int minnamelength;

    //QuickDirs
    string quickdirs[_NUMBEROFQUICKDIRS];

    //Menuoptions
    cArray<sMenuOption> menuopts;

    //Extensioncommands
    cArray<sExtCommand> extcoms;

    #ifdef _FTP_POSSIBLE_
    //FTP-settings
    cArray<cFtpSite> ftpsites;
    string anon_password;
    #endif

    //Editor options
    bool useexternaleditor;
    string externaleditor;
    int tabsize;
    bool wordwrap;

    //Miscillanous
    bool waitafterexec;
    bool alwaysrecursesubdirs;
    bool deletebackups;
    bool gotolastdir;
    bool showtipofday;
    bool clockincorner;
    bool monochromesupport;
    #ifdef _TARGETFLAVOR_UNIX_
      bool rootwarn;
    #endif

    void EditConfiguration();
  private:
    void MakeDefaultMenus();
    void MakeDefaultExt();
}/* Configuration*/;

extern cFmConfig Configuration;

#endif //_FM_CONF

