/***************************************************************************
                     fm_debug.cpp  -  handles a debuglogfile
                             -------------------
    begin                : Mon Jan 3 2000
    copyright            : (C) 2000 by MoP
    email                : sc@poulsen.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#include <fstream.h>
#include <string.h>
#include "fm_str.h"
#include "fm_debug.h"
#include "target.h"
#include "fm_vfs.h"
#include "fm_window.h"

bool _debugging_enabled=false;

bool IsDebuggingEnabled() {return _debugging_enabled;};

void EnableDebugging() {
  _debugging_enabled=true;
}

void DisableDebugging() {
  _debugging_enabled=false;
}


void InitDebugging() {
  if (!_debugging_enabled) return;
#ifdef _TARGET_LINUX_
  string s=getenv("HOME");
  s=(AddSlash(s)+"scdebug.dbg");
  DeleteFile(s);
  ofstream f(s.c_str());
//  FILE *f=fopen(s.c_str(),"w");
#else
  DeleteFile("c:/scdebug.dbg");
  ofstream f("c:/scdebug.dbg");
//  FILE *f=fopen("c:/scdebug.dbg","w");
#endif
  //if (!f) return;
  f <<"fm_debug: Debugging initialized" <<endl;
  f <<"fm_debug: target: " <<_TARGET_DESCRIPTION_ <<endl;
  f.close();
/*  fprintf(f,"fm_debug: Debugging initialized\n");
  fprintf(f,"fm_debug: Target %s%s", _TARGET_DESCRIPTION_, "\n");
  fclose(f);*/
}

void Dbg(const string& s,int i1, int i2) {
  if (!_debugging_enabled) return;
  #ifdef _TARGET_LINUX_
  string ts=getenv("HOME");
  ts=(AddSlash(ts)+"scdebug.dbg");
  ofstream f(ts.c_str(), ios::app);
//  FILE *f=fopen("/root/fmdebug.dbg","a");
//  FILE *f=fopen(ts.c_str(),"a");
#else
  ofstream f("c:/scdebug.dbg", ios::app);
//  FILE *f=fopen("c:/scdebug.dbg","a");
#endif

//  if (!f) return;
//  fprintf(f,s.c_str());
//  if (i1!=-999) fprintf(f," ",i1);
//  if (i2!=-999) fprintf(f," ",i2);
//  fprintf(f,"\n");
  f <<s;
  if (i1!=-999) f <<" " <<i1;
  if (i2!=-999) f <<" " <<i2;
  f <<endl;
  f.close();
//  fclose(f);
}


void ShowDebugInfo() {
  cInfoWindow w("DebugInfo");
  #ifdef _TARGET_TEXTIO_CURSES_
    #ifdef PDCURSES
      w+="TEXTIO: PDCURSES";
    #else
      w+="TEXTIO: CURSES";
    #endif
  #endif
  #ifdef _TARGET_TEXTIO_CONIO_
    w+="TEXTIO: CONIO";
  #endif
  w.Show();
}
