/***************************************************************************
                          fm_entry.cpp  -  description
                             -------------------
    begin                : Mon Jan 3 2000
    copyright            : (C) 2000 by MoP
    email                : fmpro@poulsen.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "fm_entry.h"

cFmEntryField::cFmEntryField(int x, int y, int length, int fg/*=cBLACK*/, int bg/*=_WINDOW_DEFAULTBG*/) {
  box=GetBoxChars();
  wx=x+1; wy=y+1; len=length;
  bgcolor=bg; fgcolor=fg;
  firsttouch=true;
  usewindow=false;
}

bool cFmEntryField::GetValue(int&) {
  return false;
}

bool cFmEntryField::GetValue(string& s, bool onlynumbers=false) {
  string work=s;
  if (work.length()>len) return false; //maybe implement later?
  tKey k;
  bool redraw=true;
  int curpos=work.length();
  do {
    if (redraw) Redraw(work,curpos);
    k=GetSomeKey();
    redraw=true;
    if (Key_LastASCIIChar()!='\0') {
      if (firsttouch) {
        work=Key_LastASCIIChar();
        curpos=1;
      } else {
        if (work.length()<len) {
          work.insert(curpos,1,Key_LastASCIIChar());
          curpos++;
        }
      }
    } else {
      switch (k) {
        case kLeft  : {if (curpos>0) curpos--;break;}
        case kRight : {if (curpos<work.length()) curpos++; break;};
        case kEnd   : {curpos=work.length(); break;};
        case kHome  : {curpos=0; break;};
        case kDelete : {
          if (firsttouch) {
            work="";
            curpos=0;
          } else {
            work.replace(curpos,1,""); break;};
          }
        case kBackspace : {if (curpos>0) work.replace(--curpos,1,"");break;};
        default : redraw=false;
      }
    }
    firsttouch=false;
  } while (!KeyIn(k,kEnter,kESC));
  if (k==kEnter) {
    s=work;
    return true;
  }
  return false; //ESC pressed
}

void cFmEntryField::Redraw(const string& s, int curpos) {
  string temp="";
  for (int i=0; i<(len-s.length()); i++) temp+=box.fillchar;
  Wr(wx+s.length(),wy,temp,fgcolor,bgcolor);
  Wr(wx,wy,s,fgcolor,bgcolor);
  ShowCursor();
  GotoXY(curpos+wx,wy);
}

bool InputWindow(const string& title, string& data, int len) {
  cWindow w(len+2,2,title);
  cFmEntryField ef(w.GetXOffset(), w.GetYOffset(), len,cBLACK,cWHITE);
  return ef.GetValue(data);
}

bool InputWindow(const string& title, int& data, int len) {
  cWindow w(len+2,2,title);
  cFmEntryField ef(w.GetXOffset(), w.GetYOffset(), len,cBLACK,cWHITE);
  return ef.GetValue(data);
}
