#include <string>
#include "target.h"
#include "fm_helpscreens.h"
#include "fm_window.h"
#include "fm_keyboard.h"

void ShowTreeHelp() {
  cInfoWindow w("TreeHelp");
  w+="Left/Right |";
  w+="Up/Down    | navigating";
  w+="PgUp/PgDn  | the tree";
  w+="Home/End   |";
  w+="";
  w+="+/Space   : Expand a branch fully";
  w+="-         : Contracts subdirs of current dir";
  w+="Insert    : Create new directory";
  w+="Delete    : Remove empty directory";
  w+="F2        : Show dirinfo";
//  w+="BackSpace : SuperChangeDirectory";
  w+="F3        : Toggle \"goto destination\"";
  w+="F5        : Refresh tree (DOS: rescan drives)";
  #ifdef _TARGET_DOS_
    w+="F6        : Show driveinfo";
  #else
    w+="F6        : Show filesysteminfo";
  #endif
  w+="";
  w+="Enter   : Choose directory";
  w+="ESCape  : Cancel choosing";
  w+="";
  w+="1-9 for accessing quickdirs";
  w+="Alt1-9 for setting quickdirs";
  w+="AltLetter for searching dirs by first letter";
  w+="Letters,/ and TAB for tab-completing search";
  w.Show();
}

void ShowViewHelp() {
  cInfoWindow w("ViewHelp");
  w+="Cursorkeys to navigate";
  w+="AltF  Find";
  w+="AltG  Find again forward";
  w+="AltV  Find again backward";
  w.Show();
}

void ShowEditHelp() {
  cInfoWindow w("EditHelp");
  w+="Cursorkeys to navigate";
  w+="F2  Save now    ShiftF2 Save as...";
  w+="F3  Begin/end selection";
  w+="ShiftF3 Clear selection";
  w+="F5  Copy marked to cursor position";
  w+="F6  Move marked to cursor position";
  w+="F8  Change textflavor (Dos/unix/mac)";
  w+="F9  Turn indention on/off";
  w+="";
  w+="AltF/F7  Find";
  w+="AltG     Find again forward";
  w+="AltV     Find again backward";
  w+="";
  w+="CtrlX  Cut selection to clipboard";
  w+="AltC   Copy selection to clipboard";
  w+="CtrlV  Past from clipboard";
  w+="CtrlY  Cut line to linebuffer";
  w+="CtrlU  Paste line from linebuffer";

  w.Show();

}

void ShowDirHelp() {
  cInfoWindow w("DirHelp");
  w+="~A Change attributes/mode      ~B Browse file (acc. to ext.)";
  w+="~C Copy file(s)                ~D Duplicate file";
  w+="~E/Del Erase file(s)           ~F Find file";
  w+="~M Move file(s)                ~U Unpack files";
  w+="~L Add to collection           ~O Process collection";
  w+="~S Create/Edit Symlink (linux) ~T Do taggin";
  w+="~Z Edit configuration file";
  
#ifdef _TARGET_LINUX
  w+="~1-~9    for chaging to quickdirs  0 for homedir";
  w+="Alt1-9 for setting quickdirs";
#else
  w+="~0-~9    for chaging to quickdirs";
  w+="Alt0-9 for setting quickdirs";
#endif

  w+="AltLetter for searching dirs by first letter";
  w+="BackSpace SuperChangeDirectory";
  w+="AltBSpace Backtrace directories";
  w+="TAB       Show some file/dirinfo";
  w+="";
  w.AddLine("General keys");
  w+="~F~1  Show Help";
  w+="~F~2  Show SystemInfo  ~F~6  Show FilesystemInfo";
  w+="~F~3  View file        ~F~4  Edit file";
  w+="~F~8  Execute command";
  w+="ShiftF1-F4  Change to console 1-4";
  w+="ShiftF5     See shellscreen N/I";

  w.Show();
}

void ShowActionHelp() {

}

void ShowSymlinksHelp() {
  cInfoWindow w("SymlinksHelp");
  w+="Symlinks were encountered, please state what to do with them";
  w+=" ~P Process  Processes symlinks without noticing what\'s linked to";
  w+=" ~R Resolve  Processes the target of the link";
  w+=" ~I Ignore   Ignores symlinks";
  w+=" ~C Cancel   Cancels the operation";
  w+="";
  w+=" Press any key to return to prompt";

  w.Show();
}
