/***************************************************************************
                  fm_keyboard.h  -  Keyboard routines
                             -------------------
    begin                : Mon Jan 3 2000
    copyright            : (C) 2000 by MoP
    email                : sc@poulsen.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#ifndef _FM_KEYBOARD
#define _FM_KEYBOARD

#define _KEYSET_YNENTERESC kEnter,kESC,kY,kN
#define _KEYSET_ALTLETTERS kAltA,kAltB,kAltC,kAltD,kAltE,kAltF,kAltG,kAltH,kAltI,kAltJ,kAltK,kAltL,kAltM,kAltN,kAltO,kAltP,kAltQ,kAltR,kAltS,kAltT,kAltU,kAltV,kAltW,kAltX,kAltY,kAltZ
#define _KEYSET_CTRLLETTERS kCtrlA,kCtrlB,kCtrlC,kCtrlD,kCtrlE,kCtrlF,kCtrlG,kCtrlH,kCtrlI,kCtrlJ,kCtrlK,kCtrlL,kCtrlM,kCtrlN,kCtrlO,kCtrlP,kCtrlQ,kCtrlR,kCtrlS,kCtrlT,kCtrlU,kCtrlV,kCtrlW,kCtrlX,kCtrlY,kCtrlZ
#define _KEYSET_ALTNUMBERS kAlt1,kAlt2,kAlt3,kAlt4,kAlt5,kAlt6,kAlt7,kAlt8,kAlt9,kAlt0
#define _KEYSET_NUMBERS k1,k2,k3,k4,k5,k6,k7,k8,k9,k0
#define _KEYSET_LETTERS kA,kB,kC,kD,kE,kF,kG,kH,kI,kJ,kK,kL,kM,kN,kO,kP,kQ,kR,kS,kT,kU,kV,kW,kX,kY,kZ

enum tKey {kDummyKey,
           kEnter, kESC, kTab, kBackspace, kDelete, kSpace, kInsert,
           kStar, kMinus, kPlus,
           kShiftDel, kCtrlDel, kAltDel, kCtrlIns, kShiftIns, kAltIns,
           kSlash, kBackSlash, kDot, kComma,

           kAltBackspace,
           
           kUp, kDown, kLeft, kRight, kHome, kEnd, kPgup, kPgdn,
           kCtrlLeft, kCtrlRight,
           kAltLeft, kAltRight,
           
           //Virtual: not physical keys, used in fm_dircon, fm_editcon, fm_viewcon
           kBlindUp, kBlindDown, kBlindRight, kBlindLeft,


           kF1,kF2,kF3,kF4,kF5,kF6,kF7,kF8,kF9,kF10,kF11,kF12,
           kShiftF1,kShiftF2,kShiftF3,kShiftF4,kShiftF5,kShiftF6,kShiftF7,kShiftF8,kShiftF9,kShiftF10,kShiftF11,kShiftF12,


           k1,k2,k3,k4,k5,k6,k7,k8,k9,k0,
           kAlt1,kAlt2,kAlt3,kAlt4,kAlt5,kAlt6,kAlt7,kAlt8,kAlt9,kAlt0,

           kA, kAltA, kCtrlA,
           kB, kAltB, kCtrlB,
           kC, kAltC, kCtrlC,
           kD, kAltD, kCtrlD,
           kE, kAltE, kCtrlE,
           kF, kAltF, kCtrlF,
           kG, kAltG, kCtrlG,
           kH, kAltH, kCtrlH,
           kI, kAltI, kCtrlI,
           kJ, kAltJ, kCtrlJ,
           kK, kAltK, kCtrlK,
           kL, kAltL, kCtrlL,
           kM, kAltM, kCtrlM,
           kN, kAltN, kCtrlN,
           kO, kAltO, kCtrlO,
           kP, kAltP, kCtrlP,
           kQ, kAltQ, kCtrlQ,
           kR, kAltR, kCtrlR,
           kS, kAltS, kCtrlS,
           kT, kAltT, kCtrlT,
           kU, kAltU, kCtrlU,
           kV, kAltV, kCtrlV,
           kW, kAltW, kCtrlW,
           kX, kAltX, kCtrlX,
           kY, kAltY, kCtrlY,
           kZ, kAltZ, kCtrlZ
          };

void InitKeyboard();
void DoneKeyboard();
bool IsKeyPressed();
tKey GetSomeKey();
void WaitKey();

char Key_LastASCIIChar();
int Key_LastNumber();

void TestKeyboard();

//Ugly, but practical...
tKey GetThatKey(tKey, tKey=kDummyKey, tKey=kDummyKey, tKey=kDummyKey,
                      tKey=kDummyKey, tKey=kDummyKey, tKey=kDummyKey,
                      tKey=kDummyKey, tKey=kDummyKey, tKey=kDummyKey,
                      tKey=kDummyKey, tKey=kDummyKey, tKey=kDummyKey);


//Ditto
bool KeyIn(tKey, tKey,tKey,      tKey=kDummyKey, tKey=kDummyKey,
                 tKey=kDummyKey, tKey=kDummyKey, tKey=kDummyKey,
                 tKey=kDummyKey, tKey=kDummyKey, tKey=kDummyKey,
                 tKey=kDummyKey, tKey=kDummyKey, tKey=kDummyKey,
                 tKey=kDummyKey, tKey=kDummyKey, tKey=kDummyKey,
                 tKey=kDummyKey, tKey=kDummyKey, tKey=kDummyKey,
                 tKey=kDummyKey, tKey=kDummyKey, tKey=kDummyKey,
                 tKey=kDummyKey, tKey=kDummyKey, tKey=kDummyKey,
                 tKey=kDummyKey, tKey=kDummyKey, tKey=kDummyKey);



//char LastChar=0;
//bool ShowTime=false;

#endif //_FM_KEYBOARD

