/***************************************************************************
                fm_menu.cpp  -  implements a cMenu-class
                             -------------------
    begin                : Mon Jan 3 2000
    copyright            : (C) 2000 by MoP
    email                : sc@poulsen.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <ctype.h>
#include "fm_menu.h"
#include "fm_keyboard.h"
#include "fm_conf.h"

cMenu::cMenu(const string& s, int bg/*=_WINDOW_DEFAULTBG*/) {
  bgcolor=bg;
  title=s;
  w_width=s.length()+3;
}

void cMenu::AddItem(const string& s) {
  if (s.length()>w_width) w_width=s.length();
  int i=s.find('~');
  if (i>-1) {
    hotkeys+=toupper(s[i+1]);
    hotpos+=menuitems.Size();
  }
  menuitems+=s;
}

int cMenu::Run(int startpos/*=1*/) {
  //make room for the >
  if (Configuration.monochromesupport && MonochromeConsole()) w_width++;
  cWindow w(w_width+1,menuitems.Size()+1, title, bgcolor);
  int current =startpos;
  bool redraw=true;
  tKey k;
  do {
    if (redraw) {
      for (int i=0; i<menuitems.Size(); i++) {
        if (i+1==current) {
          if (Configuration.monochromesupport && MonochromeConsole()) {
            w.Write(1,i+1,">"+menuitems[i],cBLACK, cRED); //highlighted
          } else {
            w.Write(1,i+1,menuitems[i],cBLACK, cRED); //highlighted
          }
        } else {
          w.Write(1,i+1,menuitems[i]); //not highlighted
        }
      }
    }
    redraw=true;
    k=GetSomeKey();
    for (int i=0; i<hotkeys.Size(); i++) {
      if (hotkeys[i]==toupper(Key_LastASCIIChar())) return hotpos[i]+1;
    }
    switch (k) {
      case kUp : {
        if (current>1) current--; else current=menuitems.size();
        break;
      }
      case kDown : {
        if (current<menuitems.Size()) current++; else current=1;
        break;
      }
      case kEnd : current=menuitems.size(); break;
      case kHome : current=1; break;

      default : redraw=false;
    }

  } while (!KeyIn(k,kEnter,kESC,kF10,kAltX));
  if (k==kEnter) return current;
  return 0;

}

