/***************************************************************************
               fm_str.cpp  -  a lot of useful string functions
                             -------------------
    begin                : Mon Jan 3 2000
    copyright            : (C) 2000 by MoP
    email                : sc@poulsen.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <stdio.h>
#include "target.h"
#include "fm_str.h"
#include "mstring.h"
#ifdef _TARGET_LINUX_
  #include <sys/stat.h>
#endif

string StrReplace(const string& s, const string& substring1, const string& substring2) {
  int i;
  string temp=s;
  while ((i=temp.find(substring1))!=-1) {
    temp.erase(i,substring1.length());
    temp.insert(i,substring2);
  }
  return temp;
}

string Upcase(const string& s) {
  string temp=s;
  for(int i=0; i<s.length(); i++) {
    temp[i]=toupper(s[i]);
  }
  return temp;
}

char Upcase(char c) {
  return toupper(c);
//  return s;
}

bool StripChar(string& s, char c1, char c2/*='\0'*/, char c3/*='\0'*/) {
  bool res=false;
  int i;
  do {
    i=s.find(c1);
    if (i>-1) {s.replace(i,1,""); res=true;};
  } while (i>-1);

  if (c2!='\0') {
    do {
      i=s.find(c2);
      if (i>-1) {s.replace(i,1,""); res=true;};
    } while (i>-1);
  }

  if (c3!='\0') {
    do {
      i=s.find(c3);
      if (i>-1) {s.replace(i,1,""); res=true;};
    } while (i>-1);
  }
  return res;
}

string MkStr(int i,bool dots/*=false*/) {
  unsigned long int l=i;
  return MkStr(l,dots);
}

string MkStr(long int i,bool dots/*=false*/) {
  unsigned long int l=i;
  return MkStr(l,dots);
}

string MkStr(unsigned long int i,bool dots/*=false*/) {
  char c[32];
  sprintf(c,"%u",i);
//  itoa(i,c,10);
  string temp=c;
  if (dots) {
    int n=temp.length();
    int p=-1;
    do {
      if (p==2) {temp.insert(n,1,'.'); p=0;} else p++;
      n--;
    } while(n);
  }
  return temp;
}


string MkStr(bool b) {
  if (b) return "yes"; else return "no";
}

string MkStr(char c) {
  char cp[2];
  cp[0]=c; cp[1]='\0';
  string temp=cp;
  return temp;
}

string MkStr(char* c) {
  string temp=c;
  return temp;
}

string MkStr(double d) {
  char buf[128];
  sprintf(buf,"%12.2f",d);
  string temp=buf;
  //strip spaces
  for (int i=0; i<temp.length(); i++) if (temp[i]!=' ') temp=temp.substr(i,999);
  return temp;
}


string MkHex(unsigned char c){
  string s;
  const char hexchars[17]="0123456789ABCDEF";
  s+=hexchars[c >> 4];
  s+=hexchars[c & 15];
  return s;
}

string MkHex(unsigned int i) {
  string s="";
  unsigned char c=(i >> 24);
  s+=MkHex(c);
  c=(i >> 16);
  s+=MkHex(c);
  c=(i >> 8);
  s+=MkHex(c);
  c=i;
  s+=MkHex(c);
  return s;
}


string LeadingSpace(const string& s, int len) {
  string temp=s;
  if (s.length()<len) {
    for(int i=0; i<len-s.length(); i++) temp=(" "+temp);
  }
  return temp;
}

string Leading0(const string& s, int len) {
  string temp=s;
  if (s.length()<len) {
    for(int i=0; i<len-s.length(); i++) temp=("0"+temp);
  }
  return temp;
}


string AddSlash(const string& s) {
  if (s=="") return "";
  string ts=s;
  if (ts[ts.length()-1]!='/') ts+='/';
  return ts;
}

string StripSlash(const string& s) {
  string ts=s;
  if (ts[ts.length()-1]=='/') ts.erase(ts.length()-1,1);//ts=(ts.substr(0,ts.length()-1));
  return ts;
}


bool Equal(const string& s1, const string& s2) {
  return (Upcase(s1)==Upcase(s2));
}

bool MatchStart(const string& s1, const string& s2) {
  if (s1.length()>s2.length()) return false;
//  if (s1.length()==0) return true;
  if (Upcase(s2.substr(0,s1.length())) == Upcase(s1)) return true;
  return false;
}

bool MatchEnd(const string& s1, const string& s2) {
  if (s1.length()>s2.length()) return false;
  if (Upcase(s2.substr(s2.length()-s1.length(),s1.length())) == Upcase(s1)) return true;
  return false;
}


/***************************************************************************

***************************************************************************/

string EndingSpace(const string& s, int len) {
  string temp=s;
  if (s.length()<len) {
    for(int i=0; i<(len-s.length()); i++) temp=temp+" ";
  }
  return temp;

}


string GetSpaces(int len) {
  string temp="";
  temp.append(_SPACES,1,len);
  return temp;
}

string Copy(const string& s, int start, int count/*=9999*/) {
  string ts=s.substr(start,count);
  return ts;
}

string LCopy(const string& s, int length, char fill/*=' '*/) {
  string temp=s.substr(0,length);
  if (temp.length()<length) {
    int l=temp.length();
    for(int i=0; i<(length-l); i++) temp+=fill;
  }

  return temp;
}

string RCopy(const string& s, int length, char fill/*=' '*/) {
  string temp;
  if (s.length()<=length) {
    temp=s;
  } else {
    temp=s.substr(s.length()-length-1,length);
  }
  if (temp.length()<length) {
    int l=temp.length();
    for(int i=0; i<(length-l); i++) temp=fill+temp;
  }
  return temp;
}

string LTrim(const string& s, int length) {
  string temp=s.substr(0,length);
  return temp;
}
string RTrim(const string& s, int length) {
  string temp;
  if (s.length()<=length) temp=s; else temp=s.substr(s.length()-length,length);
  return temp;
}

string GetPartExt(const string& s, bool handletar/*=true*/) {
  //optimize, please!!!!!!!
  int i;
  i=s.rfind('.');
  if (i==-1) return "";
  if (handletar) {
    string ts=s.substr(i,999);
    if (Upcase(ts)==".GZ" || Upcase(ts)==".BZ2") {
      int i=s.rfind(".tar.gz");
      if (i==-1) i=s.rfind(".TAR.GZ"); else return ".TAR.GZ";
      if (i!=-1) return ".TAR.GZ";
      #ifdef _BZ2_SUPPORT_
        i=s.rfind(".tar.bz2");
        if (i==-1) i=s.rfind(".TAR.BZ2"); else return ".TAR.BZ2";
        if (i!=-1) return ".TAR.BZ2";
      #endif
    }
  }
  string ts=s.substr(i,999);
  return Upcase(ts);
}

string GetPartName(const string& s) {
  int i=s.rfind('/');
  if (i>-1) {
    string ts=s.substr(i+1,999);
    return ts;
  } else return s;
}

string GetPartDir(const string& s) {
  int i=s.rfind('/');
  if (i>-1) {
    string ts=s.substr(0,i);
    return ts;
  } else return "";
}

string GetRotator() {
  static int i=0;
  switch (i) {
    case 0 : i++; return "|";
    case 1 : i++; return "/";
    case 2 : i++; return "-";
    case 3 : i++; return "\\";
    case 4 : i++; return "|";
    case 5 : i++; return "/";
    case 6 : i++; return "-";
    default : i=0; return "\\"; //7
  }
}


string GetPercent(long int part, long int total) {
  string s;
  if (total<1) return "";
  double p=part; double t=total;
  if (p>t) p=t;
  if (p<0) p=0;
  s=MkStr((int)((p*100)/t))+"%";
  return s;
}



bool SplitString(const string& s, tStringArray& cont,char seperator,int expectedparts/*=0*/, bool stripempty/*=false*/) {
  int i=s.find(seperator);
  cont.Clear();
  if (i==-1) {
    cont+=s;
    return (expectedparts==0);
  }
  string ts=s;
  while (i>-1) {
    if (stripempty) {
      if (i>0) cont+=(ts.substr(0,i)); //Do not add empty entries
      string temp=ts.substr(0,i);
      temp=temp;
    } else {
      cont+=(ts.substr(0,i));
    }
    ts=ts.substr(i+1,9999);
    i=ts.find(seperator);
  }
  if (ts!="") {
    cont+=ts;
    //return (expectedparts==0);
  }
//  if (expectedparts==0) return true;
  return (cont.Size()==expectedparts);
}



bool fnamematches (const char *fName, const char *fMask)
                 {
                   while (*fName || *fMask)
                   {
                     if (*fMask == '*')
                     {
                       while (*fMask == '*')
                         fMask++;
                       if (!*fMask)
                         return true;            // mask = "something*"
                       while (*fName && *fName != *fMask)
                         fName++;
                       if (!*fName)
                         return false;           // "*C" - fName does not contain C
                     }
                     else
                     {
                       if ((*fMask != '?')
                        && (*fName != *fMask))
                         return false;
                       if (*fMask)
                         fMask++;
                       if (*fName)
                         fName++;
                     }
                   }
                   return (!*fName) && (!*fMask);
                 }


bool WildcardMatch(const string& name, const string& mask) {
  return fnamematches(Upcase(name).c_str(),Upcase(mask).c_str());
}

string StripSurroundSpace(const string& s) {
  string temp="";
  int i=0;
  while (temp[i]==' ') i++;
  temp=s.substr(i,9999);
  i=temp.length();
  while (temp[i]==' ') i--;
  temp=temp.substr(0,i);
  return temp;
}

string FixStr(const string& s, int len) {
  if (s.length()<=len) return s;
  string news=s.substr(s.length()-len+4,999);
  news=("... "+news);
  return news;
  
}


int CountChar(const string& s, char c,bool ignorecase/*=false*/) {
  int result=0;
  for (int i=0; i<s.length(); i++) {
    if (s[i]==c) result++;
  }
  return result;
}

/*
Function RCopy(InStr : String; Count : Word; Fill : Char) : String;
Var ts : String;
    tb : Byte;
Begin


  ts:='';
  If Length(Instr)<Count Then Begin
    ts:=Instr;
    For tb:=1 to Count-Length(Instr) do ts:=Fill+ts;
  End;
  If Length(Instr)>Count Then Begin
    ts:=Copy(INstr,Length(instr)-Count,Count);
  End;
  If Length(Instr)=Count Then Begin
    ts:=INstr;
  End;
  RCopy:=ts;
End;

Function LCopy(InStr : String; Count : Word; Fill : Char) : String;
Var ts : String;
    tb : Byte;
Begin
  If Count=0 Then Begin
    LCopy:='';
    Exit;
  End;
  ts:='';
  If Length(Instr)<Count Then Begin
    ts:=Instr;
    For tb:=1 to Count-Length(Instr) do ts:=ts+Fill;
  End;
  If Length(Instr)>Count Then Begin
    ts:=Copy(INstr,1,Count);
  End;
  If Length(Instr)=Count Then Begin
    ts:=INstr;
  End;
  LCopy:=ts;

End;


Function UpCaseStr (s: String): String;
Var ts : String;
    f : Byte;
Begin
  ts:='';
  For f:=1 to Length(s) do ts:=ts+UpCase(s[f]);
  UpCaseStr:=ts;
End;


Function Leading0 (ts : String; len : Byte) : String;
Begin Leading0 := RCopy(ts, len,'0' ) End;

Function LeadingSpace (ts : String; len : Byte) : String;
Begin LeadingSpace := Rcopy(ts, len,' ') End;

Function EndingSpace ( ts : String; len : Byte) : String;
Begin
  If Length(ts)>len Then len:=Length(ts);
  EndingSpace := LCopy (ts,len,' ' )
End;


Function StrReplace ( Source, OldStr, NewStr : String ) : String;
Var p : Integer;
Begin
  While Pos ( OldStr, Source ) <> 0 Do Begin
    p := Pos ( OldStr, Source );
    Delete ( Source, p, Length ( OldStr ) );
    Insert ( NewStr, Source, p );
  End;
  StrReplace := Source;
End;

Function BPos(SubString, InString : String) : Byte;
Var tb     : Byte;
Begin
  For tb:=Length(InString) downto 1 do Begin
    If Copy(UpCaseStr(InString),tb,Length(SubString))=UpCaseStr(SubString) Then Begin
      BPos:=tb;
      Exit
    End;
  End;
  BPos:=0;
End;

Function GetProgressBar(Part, Total, Length : LongInt) : String;
Var tw : Word;
Begin
  If Part>Total Then part:=Total;
  If Part<0 Then Part:=0;
  If Total<0 Then Total:=0;
  tw := Round((Part / Total) * Length);
  GetProgressBar:=LCopy ('', tw,{''}'') + LCopy ('', Length - tw,'');
End;

Function GetPercent(Part, Total : LongInt) : String;
Var tw : Word;
    ts : String;
Begin
  If Part>Total Then part:=Total;
  If Part<0 Then Part:=0;
  If Total<0 Then Total:=0;
  tw:=((Part*100) div Total);
  Str(tw,ts);
  GetPercent:=ts+'%';

End;

Function MStr (InNumber : LongInt) : String;
Var ts : String;
Begin
  Str (InNumber, ts);
  MStr := ts;
End;

Function MStrD (InNumber : LongINt) : String;
Var ts : String;
  f, n : Integer;
Begin
  Str (InNumber, ts);
  n := (Length (ts) - 1) Div 3;
  For f := 1 To n Do Begin
    Insert ('.', ts, Length (ts) - (3 * f) + 2 - f);
  End;
  MStrD := ts;
End;

Function MVal (InStr : String) : LongInt;
Var Result : LongInt;
  ec : Integer;
Begin
  Instr:=StrReplace(Instr,' ','');
  Val (InStr, Result, ec);
  If ec = 0 Then MVal := Result Else MVal := - 1;
End;


Function CompStr ( Str1, Str2: String ): ShortInt;
Var a1,a2 : Array[0..255] of Char;
Begin
  StrPCopy(a1,str1); StrPCopy(a2,str2);
  CompStr:=StrIComp(a1,a2);
End;

Function CompStrL ( Str1, Str2: String; L : Byte ): ShortInt;
Var a1,a2 : Array[0..255] of Char;
Begin
  StrPCopy(a1,str1); StrPCopy(a2,str2);
  CompStrL:=StrLIComp(a1,a2,L);
End;

Function AddBS (ts : String) : String;
Begin
  If (ts [Length (ts) ] <> Slash) And (ts[0] > #0) Then ts := ts + Slash;
  AddBS := ts;

End;


Function StripBS (ts : String) : String;
Begin
  If ts [Length (ts) ] = Slash Then Delete (ts, Length (ts), 1);
  StripBS := ts;
End;

Function AddSlash(ts : String) : String;
Begin
  If (ts [Length (ts) ] <> '/') And (ts[0] > #0) Then ts := ts + '/'; AddSlash := ts;
End;

Function StripSlash(ts : String) : String;
Begin
  If ts [Length (ts) ] = '/' Then Delete (ts, Length (ts), 1);
  StripSlash := ts;
End;


Function IsDirTARGZ(DirName : String) : Boolean;
Begin
  If MatchEnd(DirName,'.TAR.GZ') or
     MatchEnd(DirName,'.TGZ') or
     MatchEnd(DirName,'.TAR') Then IsDirTarGZ:=TRUE else IsDirTarGZ:=FALSE;
End;


Function IsDirPackedX(DirName : String) : Boolean;
Var ts : String;
Begin
  IsDirPackedX:=FALSE;

  If IsDIrPacked(DirName) or (Pos('.EXE',UpCaseStr(DirName))<>0) Then Begin IsDirPackedX:=TRUE; Exit End;
End;

Function IsDirPacked(DirName : String) : Boolean;
Var ts : String;
Begin
  IsDirPacked:=FALSE;
  If MatchEnd(DirName,'.ZIP') Then Begin IsDirPacked:=TRUE; Exit End;
  If MatchEnd(DirName,'.RAR') Then Begin IsDirPacked:=TRUE; Exit End;
  If MatchEnd(DirName,'.TAR.GZ') Then Begin IsDirPacked:=TRUE; Exit End;
  If MatchEnd(DirName,'.TAR') Then Begin IsDirPacked:=TRUE; Exit End;
  If MatchEnd(DirName,'.ACE') Then Begin IsDirPacked:=TRUE; Exit End;
  If MatchEnd(DirName,'.TGZ') Then Begin IsDirPacked:=TRUE; Exit End;
  If MatchEnd(DirName,'.ARJ') Then Begin IsDirPacked:=TRUE; Exit End;
  If MatchEnd(DirName,'.LHA') Then Begin IsDirPacked:=TRUE; Exit End;
End;


Function GetRoot (InStr : String) : String;
Begin
  GetRoot := UpCaseStr (Copy (InStr, 1, 3) );
End;

Function WildComp (wild, Name: String): Boolean;
Begin
  WildComp := False;
  If Wild='*.*' Then Begin
    WildComp:=TRUE;
    Exit;
  End;
  Wild := UpCaseStr (Wild);
  Name := UpCaseStr (Name);
  If Name = '' Then Exit;
  Case wild [1] Of
    '*' :
         Begin
           If Name [1] = '.' Then Exit;
           If Length (wild) = 1 Then WildComp := True;
           If (Length (wild) > 1) And (wild [2] = '.') And (Length (Name) > 0)
           Then WildComp := WildComp (Copy (wild, 3, Length (wild) - 2),
             Copy (Name, Pos ('.', Name) + 1, Length (Name) - Pos ('.', Name) ) );

         End;

    '?':
        Begin
          If Ord (wild [0] ) = 1
          Then WildComp := True
          Else WildComp := WildComp (Copy (wild, 2, Length (wild) - 1),
            Copy (Name, 2, Length (Name) - 1) );
        End;
    Else If Name [1] = wild [1]
    Then If Length (wild) > 1
    Then WildComp := WildComp (Copy (wild, 2, Length (wild) - 1),
      Copy (Name, 2, Length (Name) - 1) )
    Else If (Length (Name) = 1)
            And (Length (wild) = 1)
    Then WildComp := True
    Else WildComp := False;
  End;
End;





Function GetExt (InStr : String) : String;
Var ts : String;
    tb : Byte;
Begin
  tb:=BPos ('.', InStr);
  If  tb<> 0 Then Begin
    ts := Copy (InStr, tb + 1, 3);
  End Else ts := '';
  GetExt := UpCaseStr (ts);
End;


Function Byte2Hex(B : Byte): String;       { Converts Byte to hex String }
  Const
    HexChars : Array[0..15] of Char = '0123456789ABCDEF';
  begin
    Byte2Hex[0] := #2;
    Byte2Hex[1] := HexChars[B shr  4];
    Byte2Hex[2] := HexChars[B and 15];
  end; { Byte2Hex }

Function Word2Hex(numb: Word): String;        { Converts Word to hex String.}
  begin
    Word2Hex := Byte2Hex(hi(numb))+Byte2Hex(lo(numb));
  end; { Numb2Hex }

Function Long2Hex(L: LongInt): String;     { Converts LongInt to hex String }
  begin
    Long2Hex := Word2Hex(L shr 16) + Word2Hex(L);
  end;

Function Byte2Bin(byTemp : Byte) : String;
Var
  Count : Integer;
begin
  Byte2Bin[0] := #8;
  For Count := 0 to 7 do
    Byte2Bin[8 - Count] := Char(((byTemp shr Count) and 1) + ord('0'));
end;

Function GetFilePart (DirName: String) : String;
Begin
  DirName := StripBS (DirName);
  GetFilePart := Copy (DirName, BPos (Slash, DirName) + 1, 255);
End;

Function GetDirPart (DirName: String) : String;
Begin
  DirName := StripBS (DirName);
  GetDirPart := Copy (DirName, 1, BPos (Slash, DirName) );
End;

Function ShortenPath(PathName : String; OutLength : Byte) : String;
Var ts : String;
Begin
  If Length(PathName)<=OutLength Then Begin ShortenPath:=PathName; Exit End;
  If PathName[2]=':' Then ts:=Copy(PathName,1,2)+'...'+Copy(PathName,Length(PathName)-OutLength-5,255)
                                                          Else ts:='... '+Copy(PathName,Length(PathName)-OutLength+4,255);
  ShortenPath:=ts;
End;

{Function MStrDComp(InNumber : Comp) : String;
Begin
End;}

Function MatchEnd(St, subSt : String) : Boolean;
Begin
  MatchEnd:=FALSE;
  If Length(st)<Length(subSt) Then Exit;
  If UpCaseStr(Copy(st,Length(st)-Length(subst)+1,Length(subst)))=UpCaseStr(subst) Then MatchEnd:=TRUE;
End;

Function MatchStart(St, subSt : String) : Boolean;
Begin
  MatchStart:=FALSE;
  If Length(st)<Length(subSt) Then Exit;
  If UpCaseStr(Copy(st,1,Length(subst)))=UpCaseStr(subst) Then MatchStart:=TRUE;
End;


Function MStrReal(InNumber : Real; Decs : Byte) : String;
{Function MStrReal : String;}
Var ts : String;
Begin
  Str (InNumber:2:Decs, ts);
  MStrReal := ts;
End;

CONST
    GreaterDigit = 15;
    Digits : ARRAY [0..GreaterDigit] OF Char = '0123456789ABCDEF';

FUNCTION DigitToValue (Digit : Char) : Byte;

    VAR
      Index : Byte;

  BEGIN
    Digit := UpCase (Digit);
    Index := GreaterDigit;
    WHILE (Index > 0) AND (Digit <> Digits [Index]) DO Dec (Index);
{unknow digit = 0}
    DigitToValue := Index;
  END;

  FUNCTION PositionValue (Position, Base : Byte) : LongInt;

      VAR
        Value : LongInt;
        Index : Byte;

  BEGIN
    Value := 1;
    FOR Index := 2 TO Position DO Value := Value * Base;
    PositionValue := Value;
  END;

  FUNCTION StringToValue (Str : STRING; Base : Byte) : LongInt;

      VAR
        Value : LongInt;
        Index : Byte;

  BEGIN
    Value := 0;
    FOR Index := 1 TO Length (Str) DO Inc (Value, DigitToValue (Str
      [Index]) * PositionValue (Length (Str) - Index + 1, Base));
    StringToValue := Value;
  END;

  FUNCTION ValueToString (Value : LongInt; Base : Byte) : STRING;

    VAR
      Str : STRING;

  BEGIN

    IF Value = 0 THEN Str := Digits [0] ELSE
    BEGIN
      Str := '';

      WHILE Value > 0 DO
      BEGIN
        Str := Digits [Value MOD Base] + Str;
        Value := Value DIV Base;
      END;

    END;

    ValueToString := Str;
  END;

Function IPos(SubStr, Str : String) : Byte;
Begin
  IPos:=Pos(UpCaseStr(SubStr),UpCaseStr(str));
End;

Function CountC(c : Char; s : String) : Byte;
Var tb1,tb2 : Byte;
Begin
  tb2:=0;
  For tb1:=1 to Length(s) do If s[tb1]=c Then Inc(tb2);
  CountC:=tb2;
End;

{Function GetPercent(part, Total : LongInt) : String;
Var ts : String;
Begin
  If Total<1 Then ts:='' Else Begin
    ts:=MStr(Round((PartValue / Total)*100)+'%';
  End;
  GetPercent:=ts;

End;}

End.*/
