/***************************************************************************
                          fm_viewcon.h  -  description
                             -------------------
    begin                : Mon Jan 3 2000
    copyright            : (C) 2000 by MoP
    email                : sc@poulsen.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef _FM_VIEWCON
#define _FM_VIEWCON

#include <string>
#include <stdio.h>
#include "fm_keyboard.h"
#include "fm_textfile.h"

static string findstring;

class cViewWindow {
  public:
    cViewWindow(const string&);
    ~cViewWindow();
    void Update();
    void TreatKey(tKey);
    bool Exited();
    bool Error() {return error;}
    void Idle();
    string GetTitle();
  protected:
    string filename;
    cTextFile lines;
    long int topline;
    int fromleft;
    bool error;
    bool syntax;
    bool finishedreading;

    bool Find();
    bool FindAgain();

    void DoWordWrap();

    void WriteHeader();
};


class cViewProgramOutput : public cViewWindow {
  public:
    cViewProgramOutput(const string&);
    ~cViewProgramOutput();
    void Run();
  protected:
    FILE* stdoutfile;
    bool CheckOutput();
};

bool DedicatedView(const string&);

#endif //_FM_VIEWCON
