/***************************************************************************
                          msocket.h  -  description
                             -------------------
    begin                : Thu Aug 17 2000
    copyright            : (C) 2000 by Morten Poulsen
    email                : sc@poulsen.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#ifndef _MSOCKET_H_
#define _MSOCKET_H_

#include "target.h"

#ifdef _SOCKET_SUPPORT_

#include <sys/socket.h>
#include <arpa/inet.h>
#include <netdb.h>

#define _MAXBLOCKSIZE 32768

typedef void(*sockErrorFunction)(char*, int);

class sockBase {
  public:
    sockBase(int port=8080, sockErrorFunction efunc=NULL);
    void SetErrorFunc(sockErrorFunction _efunc);
  protected:
    void sockError(char errorstring[], int errorcode=0);
    int port;
    sockErrorFunction errorfunc;
};

class sockClient : sockBase {
  public:
    sockClient(char* host="127.0.0.1", int port=8080, sockErrorFunction efunc=NULL);
    char *GetResponseFromServer(char *command);
  protected:
    char *host;
    char buf[_MAXBLOCKSIZE];
    char message[256];
    int socket_descriptor;
    struct sockaddr_in pin;
    struct hostent *server_host_name;
};


typedef void (*sockServerWorkFunc)(char*, char*, int, bool&);

class sockServer : sockBase {
  public:
    sockServer(sockServerWorkFunc workfunc, int port=8080, sockErrorFunction efunc=NULL);
    ~sockServer();
  protected:
    bool exitnow;
    sockServerWorkFunc workfunc;
    struct sockaddr_in sin;
    struct sockaddr_in pin;
    int socket_descriptor;
    int temp_socket_descriptor;
    char *temp_buf;
};


#endif //_SOCKET_SUPPORT_

#endif //_MSOCKET_H_

