#ifndef _SC_FTP
#define _SC_FTP

#include "target.h"
#ifdef _FTP_POSSIBLE_

#include <string>
#include "sc_file.h"
#include "fm_vfs.h"

#define _FTPTOKEN "[ftp-sites]"

class cFtpSite {
  public:
  string ftpsite;
  string initialdir;
  string username;
  string password;
  bool   passivemode;
};

bool EnterNewFtpSite();
bool EditFtpSite(int sitenumber);
bool DeleteFtpSite(int sitenumber);

cFile* GetFtpFilePointer(const sParsedDir&);
bool FtpScan(tDirContainer&, const string& dir, bool=false);
bool FtpDoesDirExist(const string&);
bool FtpDoesFileExist(const string&);

bool FtpSetFileMode(const string&name, const sModeChanges& md);
bool FtpDeleteFile(const string&);
bool FtpRename(const string&, const string&);
bool FtpMkDir(const string&);
bool FtpRmDir(const string&);

#endif //_FTP_POSSIBLE_

#endif //_SC_FTP
