#include <unistd.h>
#include "sc_shell.h"
#include "unicon.h"
#include "fm_conf.h"
#include "fm_entry.h"
#include "fm_defs.h"
#include "target.h"
#include "fm_window.h"
#ifdef _TARGET_DOS_
  #include <process.h>
#endif

int ExecuteCommand(const string& command, bool blind/*=false*/,bool forcenowait/*=false*/) {
  if (!blind) ClearScreenBlack();
  ConSuspend();
  #ifdef _TARGETFLAVOR_UNIX_
    string s;
    if (!getenv("SHELL")) s=""; else s+=getenv("SHELL");
    s+=(" -c \""+command+"\"");
    int result=system(s.c_str());
  #else
    int result=system(command.c_str());
  #endif

  if (Configuration.waitafterexec && !blind && !forcenowait) {
    cout <<"Press any key to return to Sunshine Commander" <<endl;
  }
  ConRestore();
  if (Configuration.waitafterexec && !blind) WaitKey();
  return result;
}


void RunProgram(const string& filename) {
  static string command="";

  if (command=="") command=filename;
  if (InputWindow("Command to execute:",command,60)) {
    if (ExecuteCommand(command)==-1) {
      ErrorBox("Unable to execute program");
    }
  }
}



bool PrintFile(const string& filename) {
  #ifdef _TARGET_UNIX_
    if (IsFileBinary(filename)) {
      if (PromptBox("Confirmation","This file seems to be binary. Are you sure you want to print it? (Y/~N)",kEnter,kESC,kN,kY)!=kY)
          return false;
    }
    string name=GetTempFileName();
    if (!CopyFile(filename,name)) return false;
    ExecuteCommand("cat "+name+" | lpr",true);
    return true;
  #else
    return false;
  #endif
}

