/***************************************************************************
                          sc_tipofday.cpp  -  description
                             -------------------
    begin                : Sat Mar 25 2000
    copyright            : (C) 2000 by Morten Poulsen
    email                : sc@poulsen.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include <time.h>
#include "sc_tipofday.h"
#include "fm_window.h"


//Suggestions for more tips?
const string tips[] = {"Did you know that:^You can end up in the dir you copy/move/unpack to?^Just use F6 when specifying the destination dir!",
                       "Did you know that:^The editor (F9) handles both DOS, Unix and Mac flavors of a textfile?^You can specify which to save in with F5!",
                       "Did you know that:^You can create your own functions using the usermenu (F8)?^Just look in the configuration-file for instructions!",
                       "Did you know that:^You can apply wordwrapping to a text shown in the viewer?^Just press w!",
                       "Did you know that:^You can always download the latest version of SC^from http://sc.poulsen.org",
                       "Did you know that:^You are more than welcome to contact the author (me)^with any comment, suggestion or bugreport?^Just mail me at sc@poulsen.org",
                       "Did you know that:^You are more than welcome to contribute to this project?^Please do not hesitate to contact me at sc@poulsen.org if you wish to help!",
                       "Did you know that:^You can use SC as a texteditor?^Simple use the command:^  Linux: scedit filename^  DOS: sc -e filename in DOS",
                       "Did you know that:^You can make SC look better in monochrome mode^See configuration (Z) for visual setup",                       
                       ""};

int CountTips() {
  int i=0; int r=0;
  do {
    if (tips[i]!="") {r++;i++;};
  } while (tips[i]!="");
  return r;
}

void ShowTipOfDay() {
  tKey k;
  int pick=CountTips();
  time_t x; tm *t; time(&x); t = gmtime(&x); //Get current time for pseudorandom number
  pick =t->tm_sec%pick;
  bool color=true;
  do {
    cInfoWindow* iw;
    if (color) iw=new cInfoWindow("Tip of the Day (#"+MkStr(pick+1)+")",cWHITE);
         else  iw=new cInfoWindow("Tip of the Day (#"+MkStr(pick+1)+")",cCYAN);
    color=!color; //Switch colors for each tip
    
    iw->SetDnRight("Space to see next tip");
    string s=tips[pick];
    int i=s.find("^");
    do {
      if (i!=-1) {
        iw->AddLine(s.substr(0,i));
        s=s.substr(i+1,999);
      }
      i=s.find("^");
    } while (i!=-1);
    iw->AddLine(s);
    k=iw->Show();
    if (k==kSpace) {pick++; if (pick>CountTips()-1) pick=0;};
  } while (k==kSpace);
}
