#include "sc_update.h"
#include "target.h"
#ifdef _SOCKET_SUPPORT_
  #include "msocket.h"
#endif

#include "fm_defs.h"
#include "fm_window.h"

bool inerror;

void error(char* message, int errorcode) {
  ErrorBox(message);
  inerror=true;
}


void CheckForUpdates() {
  #ifndef _SOCKET_SUPPORT_
    MessageBox("Not Implemented for this OS...");
    return;
  #else
  ShowMessage("Searching for update...");
  inerror=false;
  sockClient *client=new sockClient("scom.adsl.dk",12345,error);
  if (inerror) return;
  string s;
  char question[128];
  strcpy(question,"version");
  string answer=client->GetResponseFromServer(question);

  
  if (answer=="") {
    ErrorBox("Server returned no data");
    delete client;
    return;
  }
  if (answer!=_VERSION) {
    strcpy(question,"filename");
    if (answer=="") {
      ErrorBox("Server returned no data");
      delete client;
      return;
    }
    
    switch (PromptBox("Update", "New version available, "+answer+"! ([~Download])", kD, kEnter, kESC)) {
      case kD :
      case kEnter : {
        MessageBox("Not Implemented... Please visit homepage (sc.poulsen.org)");
      }
      default : ;
    }
  };
  delete client;
  return;
  #endif
}
