#ifndef _SYNTAX_DEFS_H_
#define _SYNTAX_DEFS_H_

#include <string>
#include "fm_textfile.h"
#include "unicon.h"
#include "fm_str.h"


//Add 1 to the colors as you cannot add a char(0x00) to a string (wonder why ;-))
#define COL_DEFAULT  cBLACK+1
#define COL_RESERVED cBLUE+1
#define COL_IDENT    cBLACK+1
#define COL_LITERAL  cRED+1
#define COL_COMMENT  cDGRAY+1
#define COL_STRING   cRED+1
#define COL_SYMBOL   cBLACK+1
#define COL_PREPROC  cYELLOW+1

const int __CHAR = 0;
const int __NUMBER = 1;
const int __SYMBOL = 2;
const int __SPACE = 3;
const int __EOL = 4;
const int __EOF = 5;
const int __EXTCHAR = 6;

//These should not be in use for other purposes as binary files
//are not allowed to be syntax highlighted (filtered in fm_viewcon)
const char _col = 0xff; //0x01 can be misenterpreted for color 1 when dividing string
const char _eol = 0x02;
const char _eof = 0x03;

class cParser {
  public:
    cParser();
  protected:
    tStringArray reserved_words;
    bool casesensitive;
    
    int cline, cchar;
    int currentcolor;
    char GetNextch(cTextFile& lines);
    char PeekNextch(cTextFile& lines);
    int cond;
    string temp;
    string buf;
    void Add(char ch, int col=-1);
    void AddCol(int col);
    void AddBuf();
    bool IsReserved(const string& s);
    int Classify(char c);

};

#endif //_SYNTAX_DEFS_H_


